#ifndef UCPUFREQ_H
#define UCPUFREQ_H

#include <QObject>

#include <QDBusObjectPath>

class QDBusPendingCallWatcher;

namespace core {

class CpuDBus;
class UCpufreqDBus;

class UCpufreq : public QObject {
    Q_OBJECT
public:
    UCpufreq(QObject *parent = 0);
    virtual ~UCpufreq();

    UCpufreqDBus * interface() const { return m_interface; }

    inline core::CpuDBus* cpu(const QDBusObjectPath &path) {
        return cpu(path.path());
    }

    core::CpuDBus* cpu(const QString &path);

    bool isConnected() const;

    void setGovernor(const QString &governor);
    QString governor() const;
    void setFrequency(qulonglong frequency);
    qulonglong frequency() const;

public Q_SLOTS:
    void reconnect();

    void clear();
    void save();
    void load();

private Q_SLOTS:
    void discoverCPUs();
    void discoveringFinished(QDBusPendingCallWatcher*);

    void clearCPUs();

private:
    void addCpu(QDBusObjectPath path);

Q_SIGNALS:
    void cpuAdded(core::CpuDBus*);
    // void cpuRemoved(QDBusObjectPath); ? \o/

    void connected();
    void disconnected();

private:
    UCpufreqDBus *m_interface;
    QMap<QString, CpuDBus*> m_cpus;
};

}

#endif // UCPUFREQ_H
