#include "gui/batterywidget.h"

#include "ui_battery.h"

#include "core/device.h"

using namespace gui;

BatteryWidget::BatteryWidget(core::Device *d, QWidget *parent) :
    DeviceWidget(d, parent),
    ui(new Ui::Battery) {
    ui->setupUi(this);

    ui->lowLevel->setValue(device()->lowValue());
    ui->alertLow->setChecked(device()->alertOnLow());
    ui->alertFull->setChecked(device()->alertOnFull());
    ui->timerEdit->setContextMenuPolicy(Qt::NoContextMenu);

    connect(ui->lowLevel, SIGNAL(valueChanged(double)), device(), SLOT(setLowValue(double)));
    connect(ui->alertFull, SIGNAL(toggled(bool)), device(), SLOT(setEnableFullAlert(bool)));
    connect(ui->alertLow, SIGNAL(toggled(bool)), device(), SLOT(setEnableLowAlert(bool)));

    changed();
}

BatteryWidget::~BatteryWidget() {

}

void BatteryWidget::changed() {
    ui->capacityProgress->setValue(device()->interface().capacity());
    ui->lvlProgress->setValue(device()->interface().percentage());
    ui->timerEdit->setTime(device()->timeLeft());
}
