#ifndef DEVICESTACKWIDGET_H
#define DEVICESTACKWIDGET_H

#include <QStackedWidget>

namespace core {
    class Device;
}

namespace gui {

class DeviceWidget;

class DeviceStackedWidget : public QStackedWidget {
    Q_OBJECT
public:
    DeviceStackedWidget(QWidget *parent = 0);
    ~DeviceStackedWidget();

    core::Device* device(int idx) const;
    DeviceWidget* deviceWidget(int idx) const;

private Q_SLOTS:
    void addDevice(core::Device *d);
    void removeDevice(core::Device *d);
    void removeDevice(const QString &name);

    void indexChanged(int idx);

public Q_SLOTS:
    void setCurrentDevice(core::Device *d);
    void noDevices();
};
}

#endif // DEVICESTACKWIDGET_H
