#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

namespace core {
    class Device;
}

namespace Ui {
class MainWindow;
}

namespace gui {

class MainWindow : public QMainWindow {
    Q_OBJECT
    
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

    void closeEvent(QCloseEvent *);

public Q_SLOTS:
    void display();

    void about();
    
private Q_SLOTS:
    void setMainDevice(core::Device *o, core::Device *n);
    void updateMainDevice();

    void on_action_UCpufreq_triggered();
    void on_action_Devices_triggered();
    void on_action_Settings_triggered();

    void upowerConnected();
    void upowerDisconnected();

private:
    Ui::MainWindow *ui;
};

}

#endif // MAINWINDOW_H
