#ifndef UCPUFREQTABLEWIDGET_H
#define UCPUFREQTABLEWIDGET_H

#include <QTableWidget>

namespace core {
    class CpuDBus;
}

class QComboBox;

namespace gui {
class UCpufreqTableWidget : public QTableWidget
{
    Q_OBJECT
public:
    UCpufreqTableWidget(QWidget *parent = 0);

public Q_SLOTS:
    void refresh();
    
private Q_SLOTS:
    void addCPU(core::CpuDBus *cpu);
    void available();
    void unavailable();

    void changeFrequency(int);
    void changeGovernor(int);

    void updateValues(int);
    void updateCPU();

private:
    void updateGovernorsList();
    void connectComboBoxs(QComboBox *f, QComboBox *g);
    void disconnectComboBoxs(QComboBox *f, QComboBox *g);


private:
    QStringList m_governors;
    QStringList m_frequencies_human;
    QList<qulonglong> m_frequencies;

    QList<core::CpuDBus*> m_cpus;
    QMap<QComboBox*, int> m_frequenciesCbx;
    QMap<QComboBox*, int> m_governorsCbx;

    inline int rowOfGovernorsCbx(QComboBox *c) const {
        return m_governorsCbx[c];
    }

    inline int rowOfFrequenciesCbx(QComboBox *c) const {
        return m_frequenciesCbx[c];
    }

    inline QComboBox* frequenciesComboBoxAt(int row) const {
        return m_frequenciesCbx.key(row);
    }

    inline QComboBox* governorsComboBoxAt(int row) const {
        return m_governorsCbx.key(row);
    }

private:
    static QString frequencyToString(qulonglong f);
};
}

#endif // UCPUFREQTABLEWIDGET_H
